<template>
  <div class="modelEdit container">
    <div class="box">
      <b-tabs>
        <b-tab-item label="Description">
          <h1 class="title">Description</h1>
          <b-field label="Model name">
            <b-input minlength="3" maxlength="100" size="is-large" v-model="model.name"/>
          </b-field>

          <b-field label="Short description">
            <b-input maxlength="200" type="textarea" v-model="model.shortDescription"/>
          </b-field>

          <b-field label="Long description">
            <markdownEditor v-bind:input="model.longDescription" v-on:update-description="model.longDescription = $event"/>
          </b-field>

          <b-field label="Performance">
            <b-field>
              <b-input type="number" placeholder="98" max="10000000" step="0.01" v-model="model.performance"/>
              <b-autocomplete open-on-focus placeholder="accuracy" :data="performanceTypes" v-model="model.performanceUnit" maxlength="50"/>
              <b-checkbox-button v-model="model.performanceLowerIsBetter" type="is-success">Lower is better</b-checkbox-button>
            </b-field>
          </b-field>

          <b-field label="Number of parameters">
            <b-input type="number" min="0" max="10000000" placeholder="0" v-model="model.parameterCount"/>
          </b-field>
        </b-tab-item>

        <b-tab-item label="Tags">
          <h1 class="title">Tags</h1>
          <tagEditor v-bind:modelTags="model.tags" v-on:update-tags="model.tags = $event"/>
        </b-tab-item>

        <b-tab-item label="Files">
          <h1 class="title">Files</h1>
          <h2 class="subtitle has-text-danger">Uploading files will replace the current files</h2>
          <div class="columns">
            <div class="column">
              <b-field label="Model">
                <b-upload v-model="model.file" drag-drop expanded>
                  <section class="section">
                    <div class="content has-text-centered">
                      <p>
                        <b-icon icon="upload" size="is-large"/>
                      </p>
                      <p>Drop your model here or click to upload</p>
                    </div>
                  </section>
                </b-upload>
                <span v-if="model.file" class="file-name">{{ model.file.name }}</span>
              </b-field>
            </div>
            <div class="column rightColumn">
              <layersEditor v-bind:layers="model.customLayers" v-on:update-layers="model.customLayers = $event"/>
            </div>
          </div>
        </b-tab-item>

        <b-tab-item label="Danger">
          <b-button type="is-danger" @click="removePrompt" expanded>Delete model</b-button>
        </b-tab-item>
      </b-tabs>
    </div>

    <div class="box buttons is-right">
      <b-button tag="router-link" :to="{ name: 'Account' }">Cancel</b-button>
      <b-button type="is-success" @click="openUpdateModal">Save</b-button>
    </div>

    <b-modal :active.sync="isUpdateModalActive" has-modal-card trap-focus aria-role="dialog" aria-modal>
      <ModelUpdate v-bind:model="model"/>
    </b-modal>
  </div>
</template>

<script>
import markdownEditor from '@/components/MarkdownEditor.vue'
import tagEditor from '@/components/TagEditor.vue'
import layersEditor from '@/components/LayersEditor.vue'
import ModelUpdate from '@/components/ModelUpdate.vue'
import { api } from '@/api.js'

export default {
  name: 'ModelEdit',
  components: {
    markdownEditor,
    tagEditor,
    layersEditor,
    ModelUpdate
  },
  props: {
    model: {
      type: Object,
      default: function () {
        return {}
      }
    }
  },
  data () {
    return {
      isUpdateModalActive: false,
      performanceTypes: [
        'accuracy',
        'error rate',
        'MSE'
      ]
    }
  },
  mounted () {
    this.model.tags = this.convertTag()
  },
  methods: {
    convertTag () {
      var list = []
      this.model.tags.forEach(tag => {
        list.push(tag.name)
      })
      return list
    },
    openUploadModal () {
      this.isUploadModalActive = true
    },
    removePrompt () {
      this.$buefy.dialog.confirm({
        message: 'Delete ' + this.model.name + ' ?',
        cancelText: 'Abort',
        confirmText: 'Delete',
        type: 'is-danger',
        hasIcon: true,
        onConfirm: () => api.removeModel(this.model.id)
      })
    },
    openUpdateModal () {
      this.isUpdateModalActive = true
    }
  }
}
</script>

<style scoped>
.modelEdit{
  margin-top: 20px;
}
.rightColumn {
  border-left: 2px solid whitesmoke;
}
</style>
